// File Op v0.2 by N's LAB Copyright (C) 2006 by Nobumichi Kozawa

//import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
//import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
public class FileOp
{
    public setup.KFileDialogClass kfd;
    public Form mainForm;
    public StringItem siFile, siOpen;
    public TextField tfFile;
    public ChoiceGroup cgEnc;
    public boolean write;
    private String[] sEnc;
    private boolean[] bEnc;
    private String enc, fn;
    private KKJConv kkj;
    public String sError;

    public FileOp() {
        sEnc = new String[] {"UTF-8", "UTF-16BE", "UTF-16LE", "Shift_JIS", "ISO-2022-JP", "US-ASCII"};
        bEnc = new boolean[sEnc.length];
        encTest();
        kfd = new setup.KFileDialogClass();
        mainForm = new Form("ファイルダイアログ");
        siFile = new StringItem("ファイル参照ボタン", "ファイルもしくはフォルダーの選択", Item.BUTTON);
        tfFile = new TextField("ファイル", "", 50, TextField.ANY);
        cgEnc = new ChoiceGroup("エンコード", Choice.EXCLUSIVE);
        addEnc();
        mainForm.append(siFile);
        mainForm.append(tfFile);
        mainForm.append(cgEnc);
        sError = null;
    }

    public void setMode(boolean w) {
        write = w;
        if (w) siFile.setText("保管ファイルもしくはフォルダーの選択");
        else siFile.setText("読込みファイルの選択");
    }

    public boolean setPath() {
        String path = kfd.getPathName();
        if (path.endsWith("..")) return false;
        if (!write && path.endsWith("/")) return false;
        tfFile.setString(path);
        return true;
    }

    public boolean setOpenPath(boolean list) {
        String path = kfd.getPathName();
        if (path.endsWith("..") || path.endsWith("/")) {
            if (!(!list && write && path.endsWith("/"))) {
                new Thread(new Runnable() {
                    public void run() {
                        kfd.openNext();
                    }
                }).start();
                return false;
            }
        }
        return setPath();
    }

    public boolean open(KKJConv k) {
        enc = cgEnc.getString(cgEnc.getSelectedIndex());
        fn = tfFile.getString().trim();
        kkj = k;
        boolean rc = true;
        if (0 == fn.compareTo("")) return false;
        if (write) rc = saveFile();
        else rc= readFile();
        return rc;
    }

    public boolean quickSave(KKJConv k) {    // this is for ptsNotes
        kkj = k;
        boolean rc = true;
        if (kkj.bNokia) {
            /*
            fn = "E:/Documents";
            FileConnection fc = null;
            try {
                fc = (FileConnection)Connector.open("file:///" + fn);
                if (!fc.exists()) fc.mkdir();
            } catch (Exception e) {
                sError = "mkdir, " + e;
                e.printStackTrace();
                rc = false;
            } finally {
                try {
                    if (null != fc) fc.close();
                } catch (Exception e) {}
            }
            if (rc) { */
                fn = "E:/Documents/ptsNotesQuick.txt";
                enc = "UTF-16LE";
                rc = saveFile();
//            }
        }
        return rc;
    }

    private boolean saveFile() {
        boolean rc = true;
        FileConnection fc = null;
        OutputStream os = null;
        char cData;
        sError = null;
        makeDirectories(fn);
        try {
            fc = (FileConnection)Connector.open("file:///" + fn, Connector.WRITE);
            try {
                fc.delete();
            } catch (Exception e) {
            }
            fc.create();
            //if (!fc.exists()) fc.create();
            os = fc.openOutputStream();
            OutputStreamWriter osw = new OutputStreamWriter(os, enc);
            for (int i = 0; i < kkj.sbKakutei.length(); i++) {
                cData = kkj.sbKakutei.charAt(i);
                if (kkj.cParaSepa == cData) {
                    osw.write((int)'\r');
                    osw.write((int)'\n');
                } else osw.write((int)cData);
            }
        } catch (Exception e) {
            sError = "" + e;
            e.printStackTrace();
            rc = false;
        } finally {
            try {
                if (null != os) os.close();
                if (null != fc) fc.close();
            } catch (IOException e) {
            }
        }
        return rc;
    }

    public boolean quickLoad(KKJConv k) {
        kkj = k;
        boolean rc = true;
        if (kkj.bNokia) {
            fn = "E:/Documents/ptsNotesQuick.txt";
            enc = "UTF-16LE";
            rc = readFile();
        }
        return rc;
    }

    private boolean readFile() {
        boolean rc = true, flg = false;
        int count = 0;
        FileConnection fc = null;
        InputStream is = null;
        int idat;
        char cdat;
        sError = null;
        try {
            fc = (FileConnection)Connector.open("file:///" + fn, Connector.READ);
            if (!fc.exists()) {
                throw new IOException("File not found. fn=" + fn);
            }
            is = fc.openInputStream();
            InputStreamReader isr = new InputStreamReader(is, enc);
            kkj.sbKakutei.delete(0, kkj.sbKakutei.length());
            while (-1 != (idat = isr.read())) {
                cdat = (char)idat;
                switch (cdat) {
                    case '\r' :
//                        if (flg) continue;
                        cdat = kkj.cParaSepa;
                        flg = true;
                        break;
                    case '\n' :
                        if (flg) {
                            flg = false;
                            continue;
                        }
                        cdat = kkj.cParaSepa;
//                        flg = true;
                        break;
                    default :
                        flg = false;
                }
                kkj.sbKakutei.append(cdat);
                if (++count > 8000) break;
            }
        } catch (Exception e) {
            sError = "" + e;
            e.printStackTrace();
            rc = false;
        } finally {
            try {
                if (null != is) is.close();
                if (null != fc) fc.close();
            } catch (IOException e) {
            }
        }
        kkj.buffClear();
        kkj.edit.repaint();
        return rc;
    }

    public boolean makeDirectories(String path)
    {
        int p;
        boolean rc = true;
        char delimitar = '\\';
        if (0 > (p = path.indexOf(delimitar))) {
            delimitar = '/';
            if (0 > (p = path.indexOf(delimitar)))
                delimitar = 0;
        }

        System.out.println("p = " + p + ": " + delimitar);
        while (0 < (p = path.indexOf(delimitar, p + 1))) {
            String f = path.substring(0, p);
            System.out.println(path + " " + f + " - " + p);
            try {
                FileConnection fc = (FileConnection)Connector.open("file:///" + f);
                if (!fc.exists()) {
                    System.out.println("makdir");
                    fc.mkdir();
                }
            } catch (Exception e) {
                rc = false;
                break;
            }
        }

        return rc;
    }

    private void addEnc() {
        Image im = null;
        for (int i = 0; i < bEnc.length; i++) {
            if (bEnc[i]) cgEnc.append(sEnc[i], im);
        }
    }

    private void encTest() {
        String s;
        byte[] b = {10};
        for (int i = 0; i < sEnc.length; i++) {
            try {
                s = new String(b, sEnc[i]);
                bEnc[i] = true;
            } catch (UnsupportedEncodingException e) {
                bEnc[i] = false;
            }
        }
    }
}