// Kozak's SMS Sent Box for KKJConv V1.0 by N's LAB  Copyright (C) 2007 by Nobumichi Kozawa
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
//import javax.microedition.rms.*;
//import javax.microedition.pim.*;
//import javax.wireless.messaging.*;
import java.util.*;
import java.io.*;

public class SMSSentBox implements CommandListener
{
    private final Command exitCommand = new Command("戻る", Command.EXIT, 1);
    private final Command copyCommand = new Command("コピー(漢字入力画面)", Command.ITEM, 1);
    private String dir;
    private List mainList;
    private KKJConv kkj;
    private Displayable home;
    private Display disp;
    private String yyyy, mmdd, sFname;
    private final static String enc = "UTF-8";
    private Vector vData;
    private SMSDisp smsdisp = null;

    public SMSSentBox(KKJConv k, Displayable h, String d) {
        kkj = k;
        disp = Display.getDisplay(kkj);
        home = h;
        dir = d;
        vData = new Vector();
        mainList = new List("送信済みSMSリスト", Choice.IMPLICIT);
        mainList.setFitPolicy(List.TEXT_WRAP_OFF);
        mainList.addCommand(exitCommand);
        mainList.setCommandListener(this);
    }

    public void disp() {
        String temp = (new Date()).toString().trim();
        yyyy = temp.substring(temp.length() - 4);
        String mon = getMonth(temp.substring(4, 7));
        String day = temp.substring(8, 11);
        mmdd = mon + "/" + day;
        disp.setCurrent(mainList);
        dispSMS(true);
    }

    public void commandAction(Command command, Displayable screen) {
        if (command == exitCommand) {
            if (screen == mainList) disp.setCurrent(home);
            else disp.setCurrent(mainList);
        } else if (command == copyCommand) {
            if (null != smsdisp) {
                kkj.sbKakutei.delete(0, kkj.sbKakutei.length());
                kkj.buffClear();
                kkj.sbKakutei.append(smsdisp.text);
                kkj.sSMSNumber = smsdisp.tel;
                kkj.sSMSName = smsdisp.name;
                disp.setCurrent(kkj.edit);
            }
        } else if (command == List.SELECT_COMMAND) {
            int size = vData.size();
            int sel = mainList.getSelectedIndex();
            if (sel < size) {
                if (null == smsdisp) smsdisp = new SMSDisp();
                smsdisp.disp((String)vData.elementAt(sel));
                smsdisp.mainForm.addCommand(exitCommand);
                smsdisp.mainForm.addCommand(copyCommand);
                smsdisp.mainForm.setCommandListener(this);
            } else if (sel != 0) {
                dispSMS(false);
            }
        }
    }

    private void dispSMS(final boolean first) {
        new Thread(new Runnable() {
            public void run() {
                String s;
                FileConnection fc = null;
                InputStream is = null;
                StringBuffer line = new StringBuffer();
                String date, tel, name, text;
                int idat, pos = 0, pos2;
                char cdat;

                sFname = (first) ? getCurrent(dir, yyyy) : getPrev(sFname);

                if (!first) mainList.delete(mainList.size() - 1);
                if (null != sFname) {
                    try {
                        fc = (FileConnection)Connector.open("file:///" + dir + sFname, Connector.READ);
                        if (!fc.exists()) {
                            fc.close();
                            fc = null;
                            sFname = getPrev(sFname);
                            if (null != sFname) {
                                fc = (FileConnection)Connector.open("file:///" + dir + sFname, Connector.READ);
                            }
                        }
                        if (null != fc) {
                            is = fc.openInputStream();
                            InputStreamReader isr = new InputStreamReader(is, enc);
                            line.append(sFname.substring(7, 11) + "/");
                            pos = vData.size();
                            pos2 = 0;
                            while (-1 != (idat = isr.read())) {
                                cdat = (char)idat;
                                switch (cdat) {
                                    case '\n' :
                                        if (line.length() > 16 && 3 == pos2) vData.insertElementAt(line.toString(), pos);
                                        line.delete(0, line.length());
                                        line.append(sFname.substring(7, 11) + "/");
                                        pos2 = 0;
                                        break;
                                    case '\t' : pos2++;
                                    default : line.append(cdat);
                                }
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    } finally {
                        try {
                            if (null != is) is.close();
                            if (null != fc) fc.close();
                        } catch (IOException e) {
                        }
                    }

                    int size = vData.size();
                    for (int i = pos; i < size; i++) {
                        s = (String)vData.elementAt(i);
                        date = s.substring(5, 16);
                        pos = s.indexOf("\t");
                        pos2 = s.indexOf("\t", pos + 1);
                        tel = (pos >= 0 && pos2 >= 0) ? s.substring(pos + 1, pos2) : "";
                        pos = s.indexOf("\t", pos2 + 1);
                        name = (pos >= 0 && pos2 >= 0) ? s.substring(pos2 + 1, pos) : "";
                        text = (pos >= 0) ? s.substring(pos + 1) : "";
                        line.delete(0, line.length());
                        if (s.startsWith(yyyy) && date.startsWith(mmdd)) line.append(date.substring(6, 11));
                        else line.append(date.substring(0, 5));
                        if (0 == name.compareTo("")) line.append(" [" + tel + "] ");
                        else line.append(" [" + name + "] ");
                        line.append(text);
                        mainList.insert(i, line.toString(), null);
                        mainList.setFont(i, kkj.font);
                    }

                    if (size > 0) {
                        mainList.append("次のデータを読む", null);
                    } else {
                        mainList.insert(0, "データがありません", null);
                    }
                    mainList.setFont(mainList.size() - 1, kkj.font);
                }
            }
        }).start();
    }

    public static String getMonth(String mon) {
        if (0 == mon.compareTo("Jan")) return "01";
        else if (0 == mon.compareTo("Feb")) return "02";
        else if (0 == mon.compareTo("Mar")) return "03";
        else if (0 == mon.compareTo("Apr")) return "04";
        else if (0 == mon.compareTo("May")) return "05";
        else if (0 == mon.compareTo("Jun")) return "06";
        else if (0 == mon.compareTo("Jul")) return "07";
        else if (0 == mon.compareTo("Aug")) return "08";
        else if (0 == mon.compareTo("Sep")) return "09";
        else if (0 == mon.compareTo("Oct")) return "10";
        else if (0 == mon.compareTo("Nov")) return "11";
        else if (0 == mon.compareTo("Dec")) return "12";
        return "er";
    }

    private static Enumeration readDir(String dir) {
        FileConnection fc = null;

        try {
               fc = (FileConnection)Connector.open("file:///" + dir, Connector.READ);
               return fc.list("KKJSMS*", true);
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (null != fc) fc.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    public static String getCurrent(String dir, String yyyy) {
        Enumeration en = null;

        String temp;
        String maxNum = "0";
        String fname;

        en = readDir(dir);

        if (null != en) {
               while (en.hasMoreElements()) {
                   fname = (String)en.nextElement();
                   if (fname.startsWith("KKJSMS." + yyyy)) {
                       temp = fname.substring(fname.lastIndexOf('.') + 1);
                       if (0 < temp.compareTo(maxNum)) maxNum = temp;
                   }
            }
        }

        fname = (0 == maxNum.compareTo("0")) ? "KKJSMS." + yyyy + ".000" : "KKJSMS." + yyyy + "." + maxNum;

        return fname;
    }

    /*
    private String getNext(String curr) {
        Enumeration en = readDir(dir);
        String fname;
        String temp = "KKJSMS.9999.999";
        boolean swap = false;

        if (null != en) {
               while (en.hasMoreElements()) {
                   fname = (String)en.nextElement();
                   if (fname.startsWith("KKJSMS.")) {
                       if (0 < fname.compareTo(curr)) {
                           if (0 > fname.compareTo(temp)) {
                               temp = fname;
                               swap = true;
                           }
                       }
                   }
               }
           }

           if (swap) return temp;
        return null;
    }
    */

    private String getPrev(String curr) {
        if (null != curr) {
            Enumeration en = readDir(dir);
            String fname;
            String temp = "KKJSMS.0000.000";
            boolean swap = false;

            if (null != en) {
                   while (en.hasMoreElements()) {
                       fname = (String)en.nextElement();
                       if (fname.startsWith("KKJSMS.")) {
                           if (0 > fname.compareTo(curr)) {
                               if (0 < fname.compareTo(temp)) {
                                   temp = fname;
                                   swap = true;
                               }
                           }
                       }
                   }
               }

               if (swap) return temp;
        }
        return null;
    }

    class SMSDisp
    {
        public Form mainForm;
        public String text, tel, name;
        private TextField tfTel, tfName;

        public SMSDisp() {
            mainForm = new Form("");
        }

        public void disp(String s) {
            int pos, pos2;
            mainForm.setTitle(s.substring(0, 19));
            mainForm.deleteAll();
            pos = s.indexOf("\t");
            pos2 = s.indexOf("\t", pos + 1);
            tel = (pos >= 0 && pos2 >= 0) ? s.substring(pos + 1, pos2) : "";
            pos = s.indexOf("\t", pos2 + 1);
            name = (pos2 + 1 < pos && pos >= 0 && pos2 >= 0) ? s.substring(pos2 + 1, pos) : "";
            text = (pos >= 0) ? s.substring(pos + 1) : "";
            tfTel = new TextField("", tel, tel.length() + 1, TextField.ANY | TextField.UNEDITABLE);
//            mainForm.append(tfTel);
            mainForm.append(tel + "\n");
            tfName = new TextField("", name, name.length() + 1, TextField.ANY | TextField.UNEDITABLE);
            tfName.setLayout(Item.LAYOUT_NEWLINE_AFTER);
//            mainForm.append(tfName);
            mainForm.append(name + "\n----\n");
            mainForm.append(text);

            disp.setCurrent(mainForm);
        }
    }
}
