/* Kozak's File Dialog v0.1 Copyright (C) 2006 by Nobumichi Kozawa all rights reserved */
package setup;

import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
//import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class KFileDialogClass {
    public List fileList;
    private StringBuffer sbDirName;
    private static String sTitle;

    public KFileDialogClass(String title) {
        sTitle = title;
        init();
    }

    public KFileDialogClass() {
        sTitle = "File List";
        init();
    }

    private void init() {
        sbDirName = new StringBuffer();
        fileList = new List(sTitle, Choice.IMPLICIT);
    }

    public String getPathName() {
        return sbDirName + fileList.getString(fileList.getSelectedIndex()).trim();
    }

    public void openNext() {
        int i = fileList.getSelectedIndex();
        if (fileList.getString(i).endsWith("/") || 0 == fileList.getString(i).compareTo("..")) {
            open(fileList.getString(i).trim());
        }
    }

    public void dummyAccess() {
        FileSystemRegistry.listRoots();
    }

    public void openRoot2() {
        if (0 == fileList.size()) openRoot();
    }

    public void openRoot() {
        Enumeration en;
        Image im = null;
           en = FileSystemRegistry.listRoots();
           fileList.deleteAll();
           while (en.hasMoreElements()) {
               String fn = (String)en.nextElement();
               fileList.append(fn, im);
           }
           if (sbDirName.length() > 0) sbDirName.delete(0, sbDirName.length());
        fileList.setTitle(sTitle);
    }

    public void open(String dir) {
        Enumeration en;
        Image im = null;
        FileConnection fcDir = null;
        try {
            if (0 == dir.compareTo("..")) {
                int indx = sbDirName.toString().lastIndexOf('/', sbDirName.length() - 2);
                if (indx < 0) {
                    openRoot();
                    return;
                }
                sbDirName.delete(indx + 1, sbDirName.length());
                fcDir = (FileConnection)Connector.open("file:///" + sbDirName, Connector.READ);
                //throw new IOException("++" + sbDirName);
            } else if (0 == dir.compareTo("")) {
                if (0 == sbDirName.length()) {
                    openRoot();
                    return;
                }
                fcDir = (FileConnection)Connector.open("file:///" + sbDirName, Connector.READ);
            } else {
                fcDir = (FileConnection)Connector.open("file:///" + sbDirName + dir, Connector.READ);
                sbDirName.append(dir);
            }
            en = fcDir.list();
            fcDir.close();
            fileList.deleteAll();
            fileList.append("..", im);
            int count = 0;
            while (en.hasMoreElements()) {
                fileList.append((String)en.nextElement(), im);
                if (++count > 1000) break;
            }
            fileList.setTitle(sbDirName.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
