// SMS Sent Mail Setup v1.0 by Kozak(N's LAB) Copyright (C) 2007 by Nobumichi Kozawa
package setup;

//import java.util.*;
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.io.file.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class SMSSetup implements CommandListener, ItemCommandListener
{
    private Form mainForm;
    private Displayable homeScreen;
    private Display disp;
    private ChoiceGroup cgSentFolder;
    private TextField tfSentFolder;
    private StringItem siSentFolder;
    private KFileDialogClass kfd;
    private final Command exitCommand = new Command("保管", Command.EXIT, 1);
    private final Command saveCommand = new Command("保管", Command.ITEM, 1);
    private final Command canCommand = new Command("戻る", Command.CANCEL, 1);
    private final Command folderCommand = new Command("フォルダーの選択", Command.ITEM, 1);
    private Alert alert = null;
    private int iSMSSent;
    private String sSentFolder;

    private final String defPath;

    public SMSSetup(MIDlet midlet, Displayable screen, Alert info, boolean bSonyEricsson) {
        defPath = (bSonyEricsson) ? "E:/Document/KKJConv/Sent/" : "E:/KKJConv/Sent/";
        homeScreen = screen;
        disp = Display.getDisplay(midlet);
        mainForm = new Form("SMS送信フォルダーの設定");
        String [] sa = {"NO", "YES"};
        Image[] ia = null;
        cgSentFolder = new ChoiceGroup("SMS送信フォルダーを使用しますか？", ChoiceGroup.EXCLUSIVE, sa, ia);
        mainForm.append(cgSentFolder);
        tfSentFolder = new TextField("SMS送信フォルダー", "", 50, TextField.ANY);
        mainForm.append(tfSentFolder);
        siSentFolder = new StringItem("SMS送信フォルダー参照ボタン", "送信フォルダーの場所を指定します", Item.BUTTON);
        siSentFolder.setDefaultCommand(folderCommand);
        siSentFolder.setItemCommandListener(this);
        mainForm.append(siSentFolder);
        mainForm.addCommand(exitCommand);
        mainForm.addCommand(canCommand);
        mainForm.setCommandListener(this);
        alert = info;
        loadConfig();
    }

    private void loadConfig() {
        RecordStore rsc = null;
        String sPath = null;
        byte[] ba;

        try {
            rsc = RecordStore.openRecordStore("KKJSMS", false);
            ba = rsc.getRecord(1);
            sPath = new String(ba, "UTF-8");
        } catch (Exception e) {
        } finally {
            try {
                if (null != rsc) rsc.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        if (null == sPath) {
            tfSentFolder.setString(defPath);
            iSMSSent = 0;
        } else {
            iSMSSent = (sPath.startsWith("1")) ? 1 : 0;
            tfSentFolder.setString(sPath.substring(1));
        }
        cgSentFolder.setSelectedIndex(iSMSSent, true);
    }

    private void storeConfig() {
        byte[] ba;

        try {
            try {
                RecordStore.deleteRecordStore("KKJSMS");
            } catch (RecordStoreNotFoundException e){
            }
            RecordStore rsc = RecordStore.openRecordStore("KKJSMS", true);
            String sPath = iSMSSent + sSentFolder;
            ba = sPath.getBytes("UTF-8");
            rsc.addRecord(ba, 0, ba.length);
            rsc.closeRecordStore();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void checkFolder() {
        Thread th;

        sSentFolder = tfSentFolder.getString();

        if (1 == iSMSSent) {
            th = new Thread(new Runnable() {
                public void run() {
                    boolean error = false;
                    FileConnection fc = null;

                    makeDirectories(sSentFolder);

                    try {
                        fc = (FileConnection)Connector.open("file:///" + sSentFolder, Connector.READ);
                        if (!fc.exists()) {
                            throw new IOException("フォルダーが見つかりません。");
                        }
                        if (!fc.canWrite()) {
                            throw new IOException("フォルダーが書き込み可能ではありません。");
                        }
                    } catch (IOException e) {
                        error = true;
                           Alert smsInfo = new Alert("SMS送信フォルダー");
                           smsInfo.setTimeout(5000);
                           smsInfo.setType(AlertType.ERROR);
                           smsInfo.setString(e + " フォルダーの設定を再度行ってください。");
                           disp.setCurrent(smsInfo, mainForm);
                    } finally {
                        try {
                            if (null != fc) fc.close();
                        } catch (IOException e) {
                        }
                    }
                    if (!error) {
                        storeConfig();
                        disp.setCurrent(homeScreen);
                    }
                }
            });
            th.start();

               Alert smsInfo = new Alert("SMS送信フォルダー");
               smsInfo.setTimeout(Alert.FOREVER);
               smsInfo.setType(AlertType.INFO);
               smsInfo.setString("構成を確認中です。");
            disp.setCurrent(smsInfo);
        } else {
            storeConfig();
            disp.setCurrent(homeScreen);
        }

        return;
    }

    public boolean makeDirectories(String path)
    {
        int p;
        boolean rc = true;
        char delimitar = '\\';
        if (0 > (p = path.indexOf(delimitar))) {
            delimitar = '/';
            if (0 > (p = path.indexOf(delimitar)))
                delimitar = 0;
        }
        
        String pa = path;
        if (!pa.endsWith("" + delimitar))
            pa = pa + delimitar;

        while (0 < (p = pa.indexOf(delimitar, p + 1))) {
            String f = pa.substring(0, p);
            try {
                FileConnection fc = (FileConnection)Connector.open("file:///" + f);
                if (!fc.exists()) {
                    System.out.println("makdir");
                    fc.mkdir();
                }
            } catch (Exception e) {
                rc = false;
                break;
            }
        }

        if (rc) sSentFolder = pa;
        return rc;
    }

    public void disp() {
        if (null != alert) {
            disp.setCurrent(alert, mainForm);
        } else {
            disp.setCurrent(mainForm);
        }
    }

    public void commandAction(Command command, Displayable screen) {
           if (null != kfd && screen.equals(kfd.fileList)) {
            if (List.SELECT_COMMAND == command) {
                new Thread(new Runnable() {
                    public void run() {
                        kfd.openNext();
                    }
                }).start();
            } else if (command == saveCommand) {
                String path = kfd.getPathName();
                if (path.endsWith("/")) {
                    tfSentFolder.setString(path);
                    disp.setCurrent(mainForm);
                }
            } else disp.setCurrent(mainForm);
        } else {
            if (command == exitCommand) {
                iSMSSent = cgSentFolder.getSelectedIndex();
                checkFolder();
            } else {
                disp.setCurrent(homeScreen);
            }
        }
    }

    public void commandAction(Command command, Item item) {
        if (command == folderCommand) {
            kfd = new KFileDialogClass("SMS送信フォルダーを選択し保管してください。");
            kfd.fileList.addCommand(saveCommand);
            kfd.fileList.addCommand(canCommand);
            kfd.fileList.setCommandListener(this);
            kfd.dummyAccess();
            new Thread(new Runnable() {
                public void run() {
                   kfd.openRoot();
               }
            }).start();
            disp.setCurrent(kfd.fileList);
        }
    }
}
